#include <stc15w.h>
#include <intrins.h>
#define CCP_S0 0x10
#define CCP_S1 0x20

typedef unsigned char u8;

sbit USER_DETECT=P3^2;

sbit HEAD_BUMP=P3^3;		
sbit RIGHT_BUMP=P3^6;
sbit LEFT_BUMP=P5^4;

sbit Servo=P3^7;
sbit BI=P1^0;
sbit FI=P1^1;
sbit LED=P5^5;

sbit BACK=P1^5;
sbit RIGHT=P1^4;
sbit LEFT=P1^3;
sbit HEAD=P1^2;

u8 cmd=0;								//0 STOP 1 FOLLOW 2 FORWARD 3 GO LEFT 4 GO RIGHT 5 BACKWARD
u8 motor=0;							//0 stop 1 forward 2 backward
u8 user_direction=0;		//0 ahead 1 on the left 2 on the right 3 behind
u8 turn=0;							// 0 straight 1 left 2 right
/*
u8 stop_count;
u8 follow_count;
u8 forward_count;
u8 left_count;
u8 right_count;
u8 back_count;
*/
u8 idata RX1_Buffer[32];
u8 RX1_Cnt;
u8 TX1_Cnt;
bit TX1_Busy;
bit send_flag=0;

void RX1_clear();
void UART_init();
void Uart();
void Sendcmd();
void fill_count(u8 bufferid);
void get_cmd();
void Timer0Init();
void PWM_init();
void IO_init();
void servo_driver();
void motor_driver();
void get_direction();
